﻿using System;

namespace TLS.Net.NativeAPI.SSL
{
    [Flags]
    public enum SslOptions : uint
    {
        SSL_OP_NONE = 0U,
        SSL_OP_NO_EXTENDED_MASTER_SECRET = 00000001U,
        SSL_OP_LEGACY_SERVER_CONNECT = 00000004U,
        SSL_OP_TLSEXT_PADDING = 00000010U,
        SSL_OP_SAFARI_ECDHE_ECDSA_BUG = 00000040U,
        SSL_OP_ALLOW_NO_DHE_KEX = 00000400U,
        SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS = 00000800U,
        SSL_OP_NO_QUERY_MTU = 00001000U,
        SSL_OP_COOKIE_EXCHANGE = 00002000U,
        SSL_OP_NO_TICKET = 00004000U,

        //SSL_OP_CISCO_ANYCONNECT = 00008000U, Not used, only good for deprecated DTLS1 method
        SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION = 00010000U,
        SSL_OP_NO_COMPRESSION = 00020000U,
        SSL_OP_ALLOW_UNSAFE_LEGACY_RENEGOTIATION = 00040000U,
        SSL_OP_NO_ENCRYPT_THEN_MAC = 00080000U,
        SSL_OP_ENABLE_MIDDLEBOX_COMPAT = 00100000U,
        SSL_OP_PRIORITIZE_CHACHA = 00200000U,
        SSL_OP_CIPHER_SERVER_PREFERENCE = 00400000U,
        SSL_OP_TLS_ROLLBACK_BUG = 00800000U,
        SSL_OP_NO_ANTI_REPLAY = 01000000U,
        SSL_OP_NO_SSLv3 = 02000000U,
        SSL_OP_NO_TLSv1 = 04000000U,
        SSL_OP_NO_TLSv1_2 = 08000000U,
        SSL_OP_NO_TLSv1_1 = 10000000U,
        SSL_OP_NO_TLSv1_3 = 20000000U,
        SSL_OP_NO_DTLSv1 = 04000000U,
        SSL_OP_NO_DTLSv1_2 = 08000000U,

        SSL_OP_NO_SSL_MASK = SSL_OP_NO_SSLv3 | SSL_OP_NO_TLSv1 | SSL_OP_NO_TLSv1_1 | SSL_OP_NO_TLSv1_2 |
                             SSL_OP_NO_TLSv1_3,
        SSL_OP_NO_DTLS_MASK = SSL_OP_NO_DTLSv1 | SSL_OP_NO_DTLSv1_2,
        SSL_OP_NO_RENEGOTIATION = 40000000U,
        SSL_OP_CRYPTOPRO_TLSEXT_BUG = 80000000U,

        SSL_OP_ALL = SSL_OP_CRYPTOPRO_TLSEXT_BUG |
                     SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS |
                     SSL_OP_LEGACY_SERVER_CONNECT |
                     SSL_OP_TLSEXT_PADDING |
                     SSL_OP_SAFARI_ECDHE_ECDSA_BUG
    }
}